/* Rss.c generated by valac, the Vala compiler
 * generated from Rss.vala, do not modify */

/* Meiga - Lightweight and easy to use web file server for your desktop
 *
 * Copyright (C) 2009 Igalia, S.L.
 *
 * Authors:
 *
 * Igalia, S.L. <info@igalia.com>
 * Enrique Ocaña González <eocanha@igalia.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <stdio.h>


#define TYPE_RSS_NODE (rss_node_get_type ())
#define RSS_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RSS_NODE, RssNode))
#define RSS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RSS_NODE, RssNodeClass))
#define IS_RSS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RSS_NODE))
#define IS_RSS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RSS_NODE))
#define RSS_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RSS_NODE, RssNodeClass))

typedef struct _RssNode RssNode;
typedef struct _RssNodeClass RssNodeClass;
typedef struct _RssNodePrivate RssNodePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_RSS_FEED (rss_feed_get_type ())
#define RSS_FEED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RSS_FEED, RssFeed))
#define RSS_FEED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RSS_FEED, RssFeedClass))
#define IS_RSS_FEED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RSS_FEED))
#define IS_RSS_FEED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RSS_FEED))
#define RSS_FEED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RSS_FEED, RssFeedClass))

typedef struct _RssFeed RssFeed;
typedef struct _RssFeedClass RssFeedClass;
typedef struct _RssFeedPrivate RssFeedPrivate;
#define __g_list_free_g_object_unref0(var) ((var == NULL) ? NULL : (var = (_g_list_free_g_object_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_mapped_file_free0(var) ((var == NULL) ? NULL : (var = (g_mapped_file_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _RssNode {
	GObject parent_instance;
	RssNodePrivate * priv;
};

struct _RssNodeClass {
	GObjectClass parent_class;
};

struct _RssNodePrivate {
	char* _title;
	char* _link;
	struct tm _time;
	char* _description;
	char* _content;
};

struct _RssFeed {
	GObject parent_instance;
	RssFeedPrivate * priv;
	GList* nodes;
};

struct _RssFeedClass {
	GObjectClass parent_class;
};

struct _RssFeedPrivate {
	char* _title;
	char* _link;
	char* _description;
	struct tm _time;
	char* _generator;
	char* _language;
};


static gpointer rss_node_parent_class = NULL;
static gpointer rss_feed_parent_class = NULL;

GType rss_node_get_type (void);
#define RSS_NODE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_RSS_NODE, RssNodePrivate))
enum  {
	RSS_NODE_DUMMY_PROPERTY,
	RSS_NODE_TITLE,
	RSS_NODE_LINK,
	RSS_NODE_DESCRIPTION,
	RSS_NODE_CONTENT
};
void rss_node_set_time (RssNode* self, struct tm* value);
RssNode* rss_node_new (void);
RssNode* rss_node_construct (GType object_type);
const char* rss_node_get_title (RssNode* self);
const char* rss_node_get_link (RssNode* self);
void rss_node_get_time (RssNode* self, struct tm* result);
const char* rss_node_get_description (RssNode* self);
const char* rss_node_get_content (RssNode* self);
char* rss_node_to_string (RssNode* self);
void rss_node_set_title (RssNode* self, const char* value);
void rss_node_set_link (RssNode* self, const char* value);
void rss_node_set_description (RssNode* self, const char* value);
void rss_node_set_content (RssNode* self, const char* value);
static void rss_node_finalize (GObject* obj);
static void rss_node_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void rss_node_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType rss_feed_get_type (void);
#define RSS_FEED_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_RSS_FEED, RssFeedPrivate))
enum  {
	RSS_FEED_DUMMY_PROPERTY,
	RSS_FEED_TITLE,
	RSS_FEED_LINK,
	RSS_FEED_DESCRIPTION,
	RSS_FEED_GENERATOR,
	RSS_FEED_LANGUAGE
};
static void _g_list_free_g_object_unref (GList* self);
void rss_feed_set_time (RssFeed* self, struct tm* value);
RssFeed* rss_feed_new (void);
RssFeed* rss_feed_construct (GType object_type);
const char* rss_feed_get_generator (RssFeed* self);
const char* rss_feed_get_title (RssFeed* self);
const char* rss_feed_get_link (RssFeed* self);
const char* rss_feed_get_description (RssFeed* self);
void rss_feed_get_time (RssFeed* self, struct tm* result);
const char* rss_feed_get_language (RssFeed* self);
char* rss_feed_to_string (RssFeed* self);
void rss_feed_set_title (RssFeed* self, const char* value);
void rss_feed_set_description (RssFeed* self, const char* value);
RssFeed* rss_feed_new_from_directory (const char* path, const char* base_url, const char* title, const char* description);
void rss_feed_set_link (RssFeed* self, const char* value);
void rss_feed_set_generator (RssFeed* self, const char* value);
void rss_feed_set_language (RssFeed* self, const char* value);
static void rss_feed_finalize (GObject* obj);
static void rss_feed_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void rss_feed_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static int _vala_strcmp0 (const char * str1, const char * str2);



RssNode* rss_node_construct (GType object_type) {
	RssNode * self;
	struct tm _tmp0_ = {0};
	struct tm _tmp1_;
	self = (RssNode*) g_object_new (object_type, NULL);
	rss_node_set_time (self, (_tmp1_ = (memset (&_tmp0_, 0, sizeof (struct tm)), _tmp0_), &_tmp1_));
	return self;
}


RssNode* rss_node_new (void) {
	return rss_node_construct (TYPE_RSS_NODE);
}


static char* g_time_to_string (struct tm *self) {
	char* result = NULL;
	result = g_strdup_printf ("%04d-%02d-%02d %02d:%02d:%02d", (*self).tm_year + 1900, (*self).tm_mon + 1, (*self).tm_mday, (*self).tm_hour, (*self).tm_min, (*self).tm_sec);
	return result;
}


char* rss_node_to_string (RssNode* self) {
	char* result = NULL;
	char* _tmp17_;
	char* _tmp16_;
	char* _tmp15_;
	char* _tmp14_;
	char* _tmp13_;
	char* _tmp12_;
	char* _tmp11_;
	char* _tmp10_;
	char* _tmp9_;
	char* _tmp8_;
	char* _tmp7_;
	char* _tmp6_;
	char* _tmp5_;
	char* _tmp4_;
	char* _tmp3_;
	char* _tmp2_;
	char* _tmp1_;
	char* _tmp0_;
	char* _tmp18_;
	g_return_val_if_fail (self != NULL, NULL);
	result = (_tmp18_ = g_strconcat (_tmp17_ = g_strconcat (_tmp16_ = g_strconcat (_tmp15_ = g_strconcat (_tmp14_ = g_strconcat (_tmp13_ = g_strconcat (_tmp12_ = g_strconcat (_tmp11_ = g_strconcat (_tmp10_ = g_strconcat (_tmp9_ = g_strconcat (_tmp8_ = g_strconcat (_tmp6_ = g_strconcat (_tmp5_ = g_strconcat (_tmp4_ = g_strconcat (_tmp3_ = g_strconcat (_tmp2_ = g_strconcat (_tmp1_ = g_strconcat (_tmp0_ = g_strconcat ("   <title>", self->priv->_title, NULL), "</title>\n", NULL), "   <link>", NULL), self->priv->_link, NULL), "</link>\n", NULL), "\n", NULL), "   <pubDate>", NULL), _tmp7_ = g_time_to_string (&self->priv->_time), NULL), "</pubDate>\n", NULL), "   <guid>", NULL), self->priv->_link, NULL), "</guid>\n", NULL), "   <description><![CDATA[", NULL), self->priv->_description, NULL), "]]></description>\n", NULL), "     <content:encoded><![CDATA[", NULL), self->priv->_content, NULL), "]]></content:encoded>\n", NULL), _g_free0 (_tmp17_), _g_free0 (_tmp16_), _g_free0 (_tmp15_), _g_free0 (_tmp14_), _g_free0 (_tmp13_), _g_free0 (_tmp12_), _g_free0 (_tmp11_), _g_free0 (_tmp10_), _g_free0 (_tmp9_), _g_free0 (_tmp8_), _g_free0 (_tmp7_), _g_free0 (_tmp6_), _g_free0 (_tmp5_), _g_free0 (_tmp4_), _g_free0 (_tmp3_), _g_free0 (_tmp2_), _g_free0 (_tmp1_), _g_free0 (_tmp0_), _tmp18_);
	return result;
}


const char* rss_node_get_title (RssNode* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_title;
	return result;
}


void rss_node_set_title (RssNode* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_title = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_title), _tmp0_);
	g_object_notify ((GObject *) self, "title");
}


const char* rss_node_get_link (RssNode* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_link;
	return result;
}


void rss_node_set_link (RssNode* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_link = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_link), _tmp0_);
	g_object_notify ((GObject *) self, "link");
}


void rss_node_get_time (RssNode* self, struct tm* result) {
	g_return_if_fail (self != NULL);
	*result = self->priv->_time;
	return;
}


void rss_node_set_time (RssNode* self, struct tm* value) {
	g_return_if_fail (self != NULL);
	self->priv->_time = *value;
}


const char* rss_node_get_description (RssNode* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_description;
	return result;
}


void rss_node_set_description (RssNode* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_description = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_description), _tmp0_);
	g_object_notify ((GObject *) self, "description");
}


const char* rss_node_get_content (RssNode* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_content;
	return result;
}


void rss_node_set_content (RssNode* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_content = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_content), _tmp0_);
	g_object_notify ((GObject *) self, "content");
}


static void rss_node_class_init (RssNodeClass * klass) {
	rss_node_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (RssNodePrivate));
	G_OBJECT_CLASS (klass)->get_property = rss_node_get_property;
	G_OBJECT_CLASS (klass)->set_property = rss_node_set_property;
	G_OBJECT_CLASS (klass)->finalize = rss_node_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), RSS_NODE_TITLE, g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), RSS_NODE_LINK, g_param_spec_string ("link", "link", "link", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), RSS_NODE_DESCRIPTION, g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), RSS_NODE_CONTENT, g_param_spec_string ("content", "content", "content", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void rss_node_instance_init (RssNode * self) {
	self->priv = RSS_NODE_GET_PRIVATE (self);
	self->priv->_title = g_strdup (_ ("No title"));
	self->priv->_link = g_strdup ("");
	self->priv->_description = g_strdup (_ ("No description"));
	self->priv->_content = g_strdup (_ ("No content"));
}


static void rss_node_finalize (GObject* obj) {
	RssNode * self;
	self = RSS_NODE (obj);
	_g_free0 (self->priv->_title);
	_g_free0 (self->priv->_link);
	_g_free0 (self->priv->_description);
	_g_free0 (self->priv->_content);
	G_OBJECT_CLASS (rss_node_parent_class)->finalize (obj);
}


GType rss_node_get_type (void) {
	static volatile gsize rss_node_type_id__volatile = 0;
	if (g_once_init_enter (&rss_node_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RssNodeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rss_node_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RssNode), 0, (GInstanceInitFunc) rss_node_instance_init, NULL };
		GType rss_node_type_id;
		rss_node_type_id = g_type_register_static (G_TYPE_OBJECT, "RssNode", &g_define_type_info, 0);
		g_once_init_leave (&rss_node_type_id__volatile, rss_node_type_id);
	}
	return rss_node_type_id__volatile;
}


static void rss_node_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	RssNode * self;
	self = RSS_NODE (object);
	switch (property_id) {
		case RSS_NODE_TITLE:
		g_value_set_string (value, rss_node_get_title (self));
		break;
		case RSS_NODE_LINK:
		g_value_set_string (value, rss_node_get_link (self));
		break;
		case RSS_NODE_DESCRIPTION:
		g_value_set_string (value, rss_node_get_description (self));
		break;
		case RSS_NODE_CONTENT:
		g_value_set_string (value, rss_node_get_content (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void rss_node_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	RssNode * self;
	self = RSS_NODE (object);
	switch (property_id) {
		case RSS_NODE_TITLE:
		rss_node_set_title (self, g_value_get_string (value));
		break;
		case RSS_NODE_LINK:
		rss_node_set_link (self, g_value_get_string (value));
		break;
		case RSS_NODE_DESCRIPTION:
		rss_node_set_description (self, g_value_get_string (value));
		break;
		case RSS_NODE_CONTENT:
		rss_node_set_content (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _g_list_free_g_object_unref (GList* self) {
	g_list_foreach (self, (GFunc) g_object_unref, NULL);
	g_list_free (self);
}


RssFeed* rss_feed_construct (GType object_type) {
	RssFeed * self;
	struct tm _tmp0_ = {0};
	struct tm _tmp1_;
	GList* _tmp2_;
	self = (RssFeed*) g_object_new (object_type, NULL);
	rss_feed_set_time (self, (_tmp1_ = (memset (&_tmp0_, 0, sizeof (struct tm)), _tmp0_), &_tmp1_));
	self->nodes = (_tmp2_ = NULL, __g_list_free_g_object_unref0 (self->nodes), _tmp2_);
	return self;
}


RssFeed* rss_feed_new (void) {
	return rss_feed_construct (TYPE_RSS_FEED);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


char* rss_feed_to_string (RssFeed* self) {
	char* result = NULL;
	char* _tmp27_;
	char* _tmp26_;
	char* _tmp25_;
	char* _tmp24_;
	char* _tmp23_;
	char* _tmp22_;
	char* _tmp21_;
	char* _tmp20_;
	char* _tmp19_;
	char* _tmp18_;
	char* _tmp17_;
	char* _tmp16_;
	char* _tmp15_;
	char* _tmp14_;
	char* _tmp13_;
	char* _tmp12_;
	char* _tmp11_;
	char* _tmp10_;
	char* _tmp9_;
	char* _tmp8_;
	char* _tmp7_;
	char* _tmp6_;
	char* _tmp5_;
	char* _tmp4_;
	char* _tmp3_;
	char* _tmp2_;
	char* _tmp1_;
	char* _tmp0_;
	char* _tmp28_;
	char* _result_;
	char* _tmp33_;
	g_return_val_if_fail (self != NULL, NULL);
	_result_ = (_tmp28_ = g_strconcat (_tmp27_ = g_strconcat (_tmp26_ = g_strconcat (_tmp25_ = g_strconcat (_tmp24_ = g_strconcat (_tmp23_ = g_strconcat (_tmp22_ = g_strconcat (_tmp21_ = g_strconcat (_tmp20_ = g_strconcat (_tmp18_ = g_strconcat (_tmp17_ = g_strconcat (_tmp16_ = g_strconcat (_tmp15_ = g_strconcat (_tmp14_ = g_strconcat (_tmp13_ = g_strconcat (_tmp12_ = g_strconcat (_tmp11_ = g_strconcat (_tmp10_ = g_strconcat (_tmp9_ = g_strconcat (_tmp8_ = g_strconcat (_tmp7_ = g_strconcat (_tmp6_ = g_strconcat (_tmp5_ = g_strconcat (_tmp4_ = g_strconcat (_tmp3_ = g_strconcat (_tmp2_ = g_strconcat (_tmp1_ = g_strconcat (_tmp0_ = g_strconcat ("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" "<!-- generator=\"", self->priv->_generator, NULL), "\" -->\n", NULL), "<rss version=\"2.0\" \n", NULL), "\txmlns:content=\"http://purl.org/rss/1.0/modules/content/\"\n", NULL), "\txmlns:wfw=\"http://wellformedweb.org/CommentAPI/\"\n", NULL), "\txmlns:dc=\"http://purl.org/dc/elements/1.1/\"\n", NULL), "\t>\n", NULL), "\n", NULL), "\t<channel>\n", NULL), "\t\t<title>", NULL), self->priv->_title, NULL), "</title>\n", NULL), "\t\t<link>", NULL), self->priv->_link, NULL), "</link>\n", NULL), "\t\t<description>", NULL), self->priv->_description, NULL), "</description>\n", NULL), "\t\t<pubDate>", NULL), _tmp19_ = g_time_to_string (&self->priv->_time), NULL), "</pubDate>\n", NULL), "\n", NULL), "\t\t<generator>", NULL), self->priv->_generator, NULL), "</generator>\n", NULL), "\t\t<language>", NULL), self->priv->_language, NULL), "</language>\n", NULL), _g_free0 (_tmp27_), _g_free0 (_tmp26_), _g_free0 (_tmp25_), _g_free0 (_tmp24_), _g_free0 (_tmp23_), _g_free0 (_tmp22_), _g_free0 (_tmp21_), _g_free0 (_tmp20_), _g_free0 (_tmp19_), _g_free0 (_tmp18_), _g_free0 (_tmp17_), _g_free0 (_tmp16_), _g_free0 (_tmp15_), _g_free0 (_tmp14_), _g_free0 (_tmp13_), _g_free0 (_tmp12_), _g_free0 (_tmp11_), _g_free0 (_tmp10_), _g_free0 (_tmp9_), _g_free0 (_tmp8_), _g_free0 (_tmp7_), _g_free0 (_tmp6_), _g_free0 (_tmp5_), _g_free0 (_tmp4_), _g_free0 (_tmp3_), _g_free0 (_tmp2_), _g_free0 (_tmp1_), _g_free0 (_tmp0_), _tmp28_);
	{
		GList* node_collection;
		GList* node_it;
		node_collection = self->nodes;
		for (node_it = node_collection; node_it != NULL; node_it = node_it->next) {
			RssNode* node;
			node = _g_object_ref0 ((RssNode*) node_it->data);
			{
				char* _tmp32_;
				char* _tmp31_;
				char* _tmp30_;
				char* _tmp29_;
				_result_ = (_tmp32_ = g_strconcat (_result_, _tmp31_ = g_strconcat (_tmp30_ = g_strconcat ("\t\t<item>\n" "\t\t", _tmp29_ = rss_node_to_string (node), NULL), "\t\t</item>\n", NULL), NULL), _g_free0 (_result_), _tmp32_);
				_g_free0 (_tmp31_);
				_g_free0 (_tmp30_);
				_g_free0 (_tmp29_);
				_g_object_unref0 (node);
			}
		}
	}
	_result_ = (_tmp33_ = g_strconcat (_result_, "\t</channel>\n" "</rss>\n", NULL), _g_free0 (_result_), _tmp33_);
	result = _result_;
	return result;
}


static void g_time_local (time_t time, struct tm* result) {
	struct tm _result_ = {0};
	localtime_r (&time, &_result_);
	*result = _result_;
	return;
}


RssFeed* rss_feed_new_from_directory (const char* path, const char* base_url, const char* title, const char* description) {
	RssFeed* result = NULL;
	GError * _inner_error_;
	RssFeed* rss;
	g_return_val_if_fail (path != NULL, NULL);
	g_return_val_if_fail (base_url != NULL, NULL);
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (description != NULL, NULL);
	_inner_error_ = NULL;
	rss = rss_feed_new ();
	if (title != NULL) {
		rss_feed_set_title (rss, title);
	}
	if (description != NULL) {
		rss_feed_set_description (rss, description);
	}
	{
		GFile* dir;
		GFileInfo* info;
		guint64 time;
		struct tm _tmp0_ = {0};
		struct tm _tmp1_;
		GFileEnumerator* files;
		dir = g_file_new_for_path (path);
		info = g_file_query_info (dir, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (dir);
			goto __catch12_g_error;
		}
		time = g_file_info_get_attribute_uint64 (info, G_FILE_ATTRIBUTE_TIME_MODIFIED);
		rss_feed_set_time (rss, (_tmp1_ = (g_time_local ((time_t) time, &_tmp0_), _tmp0_), &_tmp1_));
		files = g_file_enumerate_children (dir, "standard::*," G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (dir);
			_g_object_unref0 (info);
			goto __catch12_g_error;
		}
		while (TRUE) {
			GFileInfo* _tmp2_;
			GFileInfo* _tmp3_;
			RssNode* node;
			char* name;
			char* _tmp5_;
			char* _tmp4_;
			struct tm _tmp6_ = {0};
			struct tm _tmp7_;
			GFileType type;
			char* mimetype;
			_tmp2_ = g_file_enumerator_next_file (files, NULL, &_inner_error_);
			if (_inner_error_ != NULL) {
				_g_object_unref0 (dir);
				_g_object_unref0 (info);
				_g_object_unref0 (files);
				goto __catch12_g_error;
			}
			if (!((info = (_tmp3_ = _tmp2_, _g_object_unref0 (info), _tmp3_)) != NULL)) {
				break;
			}
			node = rss_node_new ();
			name = g_strdup (g_file_info_get_attribute_string (info, G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME));
			rss_node_set_title (node, name);
			rss_node_set_link (node, _tmp5_ = g_strconcat (_tmp4_ = g_strconcat (base_url, "/", NULL), name, NULL));
			_g_free0 (_tmp5_);
			_g_free0 (_tmp4_);
			time = g_file_info_get_attribute_uint64 (info, G_FILE_ATTRIBUTE_TIME_MODIFIED);
			rss_node_set_time (node, (_tmp7_ = (g_time_local ((time_t) time, &_tmp6_), _tmp6_), &_tmp7_));
			type = g_file_info_get_file_type (info);
			mimetype = g_strdup (g_file_info_get_attribute_string (info, G_FILE_ATTRIBUTE_STANDARD_FAST_CONTENT_TYPE));
			if (type == G_FILE_TYPE_DIRECTORY) {
				char* _tmp9_;
				char* _tmp8_;
				GFile* _tmp10_;
				GFile* dir2;
				GFileEnumerator* files2;
				GFileInfo* info2;
				char* node_description;
				char* _tmp22_;
				dir2 = (_tmp10_ = g_file_new_for_path (_tmp9_ = g_strconcat (_tmp8_ = g_strconcat (path, "/", NULL), name, NULL)), _g_free0 (_tmp9_), _g_free0 (_tmp8_), _tmp10_);
				files2 = g_file_enumerate_children (dir2, G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
				if (_inner_error_ != NULL) {
					_g_object_unref0 (dir2);
					_g_object_unref0 (node);
					_g_free0 (name);
					_g_free0 (mimetype);
					_g_object_unref0 (dir);
					_g_object_unref0 (info);
					_g_object_unref0 (files);
					goto __catch12_g_error;
				}
				info2 = NULL;
				node_description = g_strdup ("<ul>\n");
				while (TRUE) {
					GFileInfo* _tmp11_;
					GFileInfo* _tmp12_;
					char* name2;
					char* _tmp15_;
					char* _tmp14_;
					char* _tmp13_;
					char* _tmp16_;
					char* link2;
					char* _tmp21_;
					char* _tmp20_;
					char* _tmp19_;
					char* _tmp18_;
					char* _tmp17_;
					_tmp11_ = g_file_enumerator_next_file (files2, NULL, &_inner_error_);
					if (_inner_error_ != NULL) {
						_g_object_unref0 (dir2);
						_g_object_unref0 (files2);
						_g_object_unref0 (info2);
						_g_free0 (node_description);
						_g_object_unref0 (node);
						_g_free0 (name);
						_g_free0 (mimetype);
						_g_object_unref0 (dir);
						_g_object_unref0 (info);
						_g_object_unref0 (files);
						goto __catch12_g_error;
					}
					if (!((info2 = (_tmp12_ = _tmp11_, _g_object_unref0 (info2), _tmp12_)) != NULL)) {
						break;
					}
					name2 = g_strdup (g_file_info_get_attribute_string (info2, G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME));
					link2 = (_tmp16_ = g_strconcat (_tmp15_ = g_strconcat (_tmp14_ = g_strconcat (_tmp13_ = g_strconcat (base_url, "/", NULL), name, NULL), "/", NULL), name2, NULL), _g_free0 (_tmp15_), _g_free0 (_tmp14_), _g_free0 (_tmp13_), _tmp16_);
					node_description = (_tmp21_ = g_strconcat (node_description, _tmp20_ = g_strconcat (_tmp19_ = g_strconcat (_tmp18_ = g_strconcat (_tmp17_ = g_strconcat ("<li><a href=\"", link2, NULL), "\">", NULL), name2, NULL), "</a></li>\n", NULL), NULL), _g_free0 (node_description), _tmp21_);
					_g_free0 (_tmp20_);
					_g_free0 (_tmp19_);
					_g_free0 (_tmp18_);
					_g_free0 (_tmp17_);
					_g_free0 (name2);
					_g_free0 (link2);
				}
				node_description = (_tmp22_ = g_strconcat (node_description, "<ul>\n", NULL), _g_free0 (node_description), _tmp22_);
				rss_node_set_description (node, node_description);
				_g_object_unref0 (dir2);
				_g_object_unref0 (files2);
				_g_object_unref0 (info2);
				_g_free0 (node_description);
			} else {
				if (mimetype == NULL) {
					char* _tmp23_;
					mimetype = (_tmp23_ = g_strdup ("application/x-octet-stream"), _g_free0 (mimetype), _tmp23_);
				}
				if (g_str_has_prefix (mimetype, "image/")) {
					char* _tmp24_;
					rss_node_set_description (node, _tmp24_ = g_strdup_printf ("<img src=\"%s\" width=\"300\" />", rss_node_get_link (node)));
					_g_free0 (_tmp24_);
				} else {
					if (_vala_strcmp0 (mimetype, "text/plain") == 0) {
						char* _tmp26_;
						char* _tmp25_;
						GMappedFile* _tmp27_;
						GMappedFile* f;
						char* _tmp28_;
						f = (_tmp27_ = g_mapped_file_new (_tmp26_ = g_strconcat (_tmp25_ = g_strconcat (path, "/", NULL), name, NULL), FALSE, &_inner_error_), _g_free0 (_tmp26_), _g_free0 (_tmp25_), _tmp27_);
						if (_inner_error_ != NULL) {
							_g_object_unref0 (node);
							_g_free0 (name);
							_g_free0 (mimetype);
							_g_object_unref0 (dir);
							_g_object_unref0 (info);
							_g_object_unref0 (files);
							goto __catch12_g_error;
						}
						rss_node_set_description (node, _tmp28_ = g_strdup_printf ("<pre>%s</pre>\n", (const char*) g_mapped_file_get_contents (f)));
						_g_free0 (_tmp28_);
						_g_mapped_file_free0 (f);
					} else {
						if (_vala_strcmp0 (mimetype, "text/html") == 0) {
							char* _tmp30_;
							char* _tmp29_;
							GMappedFile* _tmp31_;
							GMappedFile* f;
							char* _tmp32_;
							f = (_tmp31_ = g_mapped_file_new (_tmp30_ = g_strconcat (_tmp29_ = g_strconcat (path, "/", NULL), name, NULL), FALSE, &_inner_error_), _g_free0 (_tmp30_), _g_free0 (_tmp29_), _tmp31_);
							if (_inner_error_ != NULL) {
								_g_object_unref0 (node);
								_g_free0 (name);
								_g_free0 (mimetype);
								_g_object_unref0 (dir);
								_g_object_unref0 (info);
								_g_object_unref0 (files);
								goto __catch12_g_error;
							}
							rss_node_set_description (node, _tmp32_ = g_strdup_printf ("%s\n", (const char*) g_mapped_file_get_contents (f)));
							_g_free0 (_tmp32_);
							_g_mapped_file_free0 (f);
						} else {
							char* _tmp33_;
							rss_node_set_description (node, _tmp33_ = g_strdup_printf (_ ("<a href=\"%s\">Download %s</a>\n"), rss_node_get_link (node), rss_node_get_title (node)));
							_g_free0 (_tmp33_);
						}
					}
				}
			}
			rss_node_set_content (node, rss_node_get_description (node));
			rss->nodes = g_list_append (rss->nodes, _g_object_ref0 (node));
			_g_object_unref0 (node);
			_g_free0 (name);
			_g_free0 (mimetype);
		}
		_g_object_unref0 (dir);
		_g_object_unref0 (info);
		_g_object_unref0 (files);
	}
	goto __finally12;
	__catch12_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			fprintf (stderr, "%s", _ ("RssFeed.new_from_directory(): Error\n"));
			_g_error_free0 (e);
		}
	}
	__finally12:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (rss);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = rss;
	return result;
}


const char* rss_feed_get_title (RssFeed* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_title;
	return result;
}


void rss_feed_set_title (RssFeed* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_title = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_title), _tmp0_);
	g_object_notify ((GObject *) self, "title");
}


const char* rss_feed_get_link (RssFeed* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_link;
	return result;
}


void rss_feed_set_link (RssFeed* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_link = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_link), _tmp0_);
	g_object_notify ((GObject *) self, "link");
}


const char* rss_feed_get_description (RssFeed* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_description;
	return result;
}


void rss_feed_set_description (RssFeed* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_description = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_description), _tmp0_);
	g_object_notify ((GObject *) self, "description");
}


void rss_feed_get_time (RssFeed* self, struct tm* result) {
	g_return_if_fail (self != NULL);
	*result = self->priv->_time;
	return;
}


void rss_feed_set_time (RssFeed* self, struct tm* value) {
	g_return_if_fail (self != NULL);
	self->priv->_time = *value;
}


const char* rss_feed_get_generator (RssFeed* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_generator;
	return result;
}


void rss_feed_set_generator (RssFeed* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_generator = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_generator), _tmp0_);
	g_object_notify ((GObject *) self, "generator");
}


const char* rss_feed_get_language (RssFeed* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_language;
	return result;
}


void rss_feed_set_language (RssFeed* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_language = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_language), _tmp0_);
	g_object_notify ((GObject *) self, "language");
}


static void rss_feed_class_init (RssFeedClass * klass) {
	rss_feed_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (RssFeedPrivate));
	G_OBJECT_CLASS (klass)->get_property = rss_feed_get_property;
	G_OBJECT_CLASS (klass)->set_property = rss_feed_set_property;
	G_OBJECT_CLASS (klass)->finalize = rss_feed_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), RSS_FEED_TITLE, g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), RSS_FEED_LINK, g_param_spec_string ("link", "link", "link", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), RSS_FEED_DESCRIPTION, g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), RSS_FEED_GENERATOR, g_param_spec_string ("generator", "generator", "generator", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), RSS_FEED_LANGUAGE, g_param_spec_string ("language", "language", "language", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void rss_feed_instance_init (RssFeed * self) {
	self->priv = RSS_FEED_GET_PRIVATE (self);
	self->priv->_title = g_strdup (_ ("No title"));
	self->priv->_link = g_strdup ("");
	self->priv->_description = g_strdup (_ ("No description"));
	self->priv->_generator = g_strdup_printf ("%s/%s", PACKAGE, VERSION);
	self->priv->_language = g_strdup (_ ("en"));
}


static void rss_feed_finalize (GObject* obj) {
	RssFeed * self;
	self = RSS_FEED (obj);
	_g_free0 (self->priv->_title);
	_g_free0 (self->priv->_link);
	_g_free0 (self->priv->_description);
	_g_free0 (self->priv->_generator);
	_g_free0 (self->priv->_language);
	__g_list_free_g_object_unref0 (self->nodes);
	G_OBJECT_CLASS (rss_feed_parent_class)->finalize (obj);
}


GType rss_feed_get_type (void) {
	static volatile gsize rss_feed_type_id__volatile = 0;
	if (g_once_init_enter (&rss_feed_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RssFeedClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rss_feed_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RssFeed), 0, (GInstanceInitFunc) rss_feed_instance_init, NULL };
		GType rss_feed_type_id;
		rss_feed_type_id = g_type_register_static (G_TYPE_OBJECT, "RssFeed", &g_define_type_info, 0);
		g_once_init_leave (&rss_feed_type_id__volatile, rss_feed_type_id);
	}
	return rss_feed_type_id__volatile;
}


static void rss_feed_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	RssFeed * self;
	self = RSS_FEED (object);
	switch (property_id) {
		case RSS_FEED_TITLE:
		g_value_set_string (value, rss_feed_get_title (self));
		break;
		case RSS_FEED_LINK:
		g_value_set_string (value, rss_feed_get_link (self));
		break;
		case RSS_FEED_DESCRIPTION:
		g_value_set_string (value, rss_feed_get_description (self));
		break;
		case RSS_FEED_GENERATOR:
		g_value_set_string (value, rss_feed_get_generator (self));
		break;
		case RSS_FEED_LANGUAGE:
		g_value_set_string (value, rss_feed_get_language (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void rss_feed_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	RssFeed * self;
	self = RSS_FEED (object);
	switch (property_id) {
		case RSS_FEED_TITLE:
		rss_feed_set_title (self, g_value_get_string (value));
		break;
		case RSS_FEED_LINK:
		rss_feed_set_link (self, g_value_get_string (value));
		break;
		case RSS_FEED_DESCRIPTION:
		rss_feed_set_description (self, g_value_get_string (value));
		break;
		case RSS_FEED_GENERATOR:
		rss_feed_set_generator (self, g_value_get_string (value));
		break;
		case RSS_FEED_LANGUAGE:
		rss_feed_set_language (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




